<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2010 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_4/lang/en-US.php $
 * $Id: en-US.php 1764 2010-10-01 01:13:32Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$lang['en-US'] = array(
	// Display name for language (within Preferences)
	'LANG_ID'	=> 'English (United States)',
	// Language code as reported in <html> tag
	'LANG_CODE'	=> 'en-US',
	// Text direction as reported in <html> tag
	'LANG_DIR'	=> 'ltr',
	// Location of additional strings for this language (within lang directory)
	// as well as guide pages (in "guide/" directory within this path)
	'LANG_PATH'	=> 'en-US/',
	// Various language-dependent string formatting routines
	'FUNC_FORMAT_LIST'	=> 'en_us_format_list',
	'FUNC_FORMAT_LABEL'	=> 'en_us_format_label',
	'FUNC_FORMAT_NUMBER'	=> 'en_us_format_number',
	'FUNC_FORMAT_PRENUM'	=> 'en_us_format_prenum',
	'FUNC_FORMAT_MONEY'	=> 'en_us_format_money',
	'FUNC_FORMAT_PERCENT'	=> 'en_us_format_percent',
	'FUNC_UNFORMAT_NUMBER'	=> 'en_us_unformat_number',
	'FUNC_TRUNCATE'		=> 'en_us_truncate',
);
function en_us_format_list ($list)
{
	if (count($list) == 0)
		return '';
	if (count($list) == 1)
		return array_shift($list);
	if (count($list) == 2)
		return array_shift($list) .' and '. array_shift($list);

	$out = '';
	while (count($list) > 1)
		$out .= array_shift($list) .', ';
	$out .= 'and '. array_shift($list);
	return $out;
}
function en_us_format_label ($label, $value = NULL)
{
	if (isset($value))
		return $label .': '. $value;
	else	return $label .':';
}
function en_us_format_number ($num)
{
	return number_format($num, 0, '.', ',');
}
function en_us_format_prenum ($num)
{
	return '#'. number_format($num, 0, '.', ',');
}
function en_us_format_money ($num)
{
	if ($num < 0)
		return '-$'. number_format(abs($num), 0, '.', ',');
	else	return '$'. number_format($num, 0, '.', ',');
}
function en_us_format_percent ($num, $decimal)
{
	return number_format($num, $decimal, '.', ',') .'%';
}
function en_us_unformat_number ($num)
{
	return str_replace(array('$', '#', '%', ','), '', $num);
}
function en_us_truncate ($str, $len)
{
	if (strlen($str) > $len)
		$str = substr($str, 0, $len - 3) .'...';
	return $str;
}
?>
