<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2010 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_4/pages/banner.php $
 * $Id: banner.php 1764 2010-10-01 01:13:32Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

function giveBonusTurns ()
{
	global $db, $lock;
	global $user1, $emp1;

	if (!ROUND_STARTED)
		return 0;	// don't give turns if the game isn't running

	// page_header() isn't called here, so we have to do all of this manually

	$auth = checkAuth();
	if ($auth != '')
		return 0;

	if ($emp1->e_freeturns >= CUR_TIME)
		return 0;	// already got free turns

	$turnbonus = ceil(60 / TURNS_FREQ) * TURNS_COUNT;

	// update $lock for logging purposes
	$lock['emp1'] = $emp1->e_id;
	prom_entity::lock_entities(array($emp1), $user1->u_id);

	$emp1->e_freeturns = CUR_TIME + 86400;
	$emp1->e_turns += $turnbonus;
	if ($emp1->e_turns > TURNS_MAXIMUM)
	{
		$emp1->e_storedturns += $emp1->e_turns - TURNS_MAXIMUM;
		$emp1->e_turns = TURNS_MAXIMUM;
		if ($emp1->e_storedturns > TURNS_STORED)
			$emp1->e_storedturns = TURNS_STORED;
	}
	$emp1->save();	// give 1 hour worth of turns and reset timer
	return $turnbonus;
}

$dest = 'game';	// In the event of failure, jump back to this page
if ($action == 'click')
{
	$id = fixInputNum(getFormVar('banner_id'));
	if (isset($banners[$id]))
	{
		if (BONUS_TURNS)
			$turns = giveBonusTurns();
		$url = $banners[$id]['url'];
		if ($banners[$id]['ismap'])
		{
			$click_x = fixInputNum(getFormVar('banner_img_x'));
			$click_y = fixInputNum(getFormVar('banner_img_y'));
			$url .= '?'. $click_x .','. $click_y;
		}
		logevent(varlist(array('turns', 'id'), get_defined_vars()));
		redirect($url);
	}
}
elseif ($action == 'bonus')
{
	if (count($banners) == 0)
	{
		if (BONUS_TURNS)
			$turns = giveBonusTurns();
		logevent(varlist(array('turns'), get_defined_vars()));
		$dest = getFormVar('bonus_return', 'game');
	}
}
redirect(URL_BASE .'?location='. urlencode($dest));
?>
