<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2010 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_4/pages/graveyard.php $
 * $Id: graveyard.php 1764 2010-10-01 01:13:32Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'GRAVEYARD_TITLE';

page_header();

function graveHeader ($color)
{
?>
<tr class="era<?=$color?>">
    <th class="ac"><?=lang('COLUMN_EMPIRE')?></th>
<?	if (GRAVEYARD_DISCLOSE) { ?>
    <th class="ac"><?=lang('COLUMN_USER')?></th>
<?	} ?>
    <th class="ac"><?=lang('COLUMN_LAND')?></th>
    <th class="ar"><?=lang('COLUMN_NETWORTH')?></th>
<?	if (CLAN_ENABLE) { ?>
    <th class="ac"><?=lang('COLUMN_CLAN')?></th>
<?	} ?>
    <th class="ac"><?=lang('COLUMN_RACE')?></th>
    <th class="ac"><?=lang('COLUMN_ERA')?></th>
    <th class="ac"><?=lang('COLUMN_DEATH')?></th></tr>
<?
}
function graveLine ($emp, $reason)
{
	global $cnames, $races, $eras;
?>
<tr class="mdead">
    <td class="ac"><?=$emp?></td>
<?	if (GRAVEYARD_DISCLOSE) { ?>
    <td class="ac"><a href="?location=playerstats&amp;id=<?=$emp->u_oldid?>" rel="external"><?=lang('COMMON_USER_NAMEID', $emp->u_name, prenum($emp->u_oldid))?></a></td>
<?	} ?>
    <td class="ac"><?=number($emp->e_land)?></td>
    <td class="ar"><?=money($emp->e_networth)?></td>
<?	if (CLAN_ENABLE) { ?>
    <td class="ac"><?=$cnames[$emp->c_oldid]?></td>
<?	} ?>
    <td class="ac"><?=$races[$emp->e_race]?></td>
    <td class="ac"><?=$eras[$emp->e_era]?></td>
    <td class="ac"><?=$reason?></td></tr>
<?
}
?>
<?=lang('GRAVEYARD_HEADER')?><br />
<table class="scorestable">
<?
$q = $db->query('SELECT e_name,e_id,e_land,e_networth,c_id,c_oldid,e_race,e_era,e_killedby,e_killclan,e_flags,u_oldid,u_name '.
		'FROM '. EMPIRE_TABLE .' e '.
		'LEFT OUTER JOIN '. USER_TABLE .' u ON (e.u_oldid = u.u_id) '.
		'WHERE e.u_id = 0 '.
		'ORDER BY e_networth DESC') or warning('Failed to fetch dead empires', 0);
$graves = $q->fetchAll();
if (count($graves) > 0)
{
	graveHeader($emp1->e_era);
	foreach ($graves as $data)
	{
		$emp_a = new prom_empire($data['e_id']);
		$emp_a->initdata($data);

		if ($emp_a->e_killedby == 0)
			$reason = lang('GRAVEYARD_LABEL_ABANDONED');
		elseif ($emp_a->e_killedby == $emp_a->e_id)
			$reason = lang('GRAVEYARD_LABEL_SUICIDED');
		else
		{
			$emp_b = new prom_empire($emp_a->e_killedby);
			$emp_b->loadPartial();
			if ($emp_a->e_flags & EFLAG_DELETE)
				$reason = lang('GRAVEYARD_LABEL_NUKED', $emp_b);
			elseif (CLAN_ENABLE && $emp_a->e_killclan)
				$reason = lang('GRAVEYARD_LABEL_KILLED_CLAN', $emp_b, $cnames[$emp_a->e_killclan]);
			else	$reason = lang('GRAVEYARD_LABEL_KILLED_NOCLAN', $emp_b);
			$emp_b = NULL;
		}
		graveLine($emp_a, $reason);
		$emp_a = NULL;
	}
	graveHeader($emp1->e_era);
}
?>
</table>
<?
page_footer();
?>
