<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2010 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_4/pages/manage.php $
 * $Id: manage.php 1764 2010-10-01 01:13:32Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'MANAGE_TITLE';

$lock['user1'] = -1;
page_header();

// killUnits($emp, 'unit', 0.20, 0.40) will destroy 20%-40% of a unit, biased toward 30%
function killUnits ($emp, $type, $minpc, $maxpc)
{
	$losspct = gauss_rand($minpc, $maxpc);
	$loss = round($emp->getData($type) * $losspct);
	$emp->subData($type, $loss);
	return $loss;
}

// Empire Settings
if ($action == 'polymorph') do
{
	$race = fixInputNum(getFormVar('polymorph_race'));
	$confirm = fixInputBool(getFormVar('polymorph_confirm'));

	// If the round hasn't started, nobody's used any turns
	// so it's okay for them to polymorph
	if (ROUND_FINISHED)
	{
		notice(lang('MANAGE_POLYMORPH_UNAVAILABLE'));
		break;
	}
	if (!$race)
	{
		notice(lang('MANAGE_POLYMORPH_NEED_RACE'));
		break;
	}
	if (!prom_race::exists($race))
	{
		notice(lang('MANAGE_POLYMORPH_BAD_RACE'));
		break;
	}
	if ($race == $emp1->e_race)
	{
		notice(lang('MANAGE_POLYMORPH_SAME_RACE'));
		break;
	}
	if ($emp1->e_turnsused == 0)
	{	// don't need to confirm if no turns have been used
		$emp1->e_race = $race;
		$emp1->race = new prom_race($race);
		notice(lang('MANAGE_POLYMORPH_FREE'));
		logevent(varlist(array('race'), get_defined_vars()));
		break;
	}
	if (!$confirm)
	{
		notice(lang('MANAGE_POLYMORPH_NEED_CONFIRM'));
		break;
	}
	if ($emp1->e_turns < TURNS_INITIAL)
	{
		notice(lang('MANAGE_POLYMORPH_NEED_TURNS'));
		break;
	}
	if ($emp1->e_health < 75)
	{
		notice(lang('MANAGE_POLYMORPH_NEED_HEALTH'));
		break;
	}
	if ($emp1->e_trpwiz < $emp1->e_land * 3)
	{
		notice(lang('MANAGE_POLYMORPH_NEED_TRPWIZ', $emp1->era->trpwiz));
		break;
	}
	$emp1->e_health -= 50;
	$emp1->e_turns -= TURNS_INITIAL;
	notice(lang('MANAGE_POLYMORPH_BEGIN', $emp1->era->trpwiz));
	$losearm = killUnits($emp1, 'e_trparm', 0.10, 0.15);
	$loselnd = killUnits($emp1, 'e_trplnd', 0.10, 0.15);
	$losefly = killUnits($emp1, 'e_trpfly', 0.10, 0.15);
	$losesea = killUnits($emp1, 'e_trpsea', 0.10, 0.15);
	$losepeasants = killUnits($emp1, 'e_peasants', 0.10, 0.15);
	$losewiz = killUnits($emp1, 'e_trpwiz', 0.10, 0.15);
	notice(lang('MANAGE_POLYMORPH_UNITS_LOST',
		number($losearm), $emp1->era->trparm,
		number($loselnd), $emp1->era->trplnd,
		number($losefly), $emp1->era->trpfly,
		number($losesea), $emp1->era->trpsea,
		number($losepeasants), $emp1->era->peasants,
		number($losewiz), $emp1->era->trpwiz));
	$losebld = 0;
	$losebld += killUnits($emp1, 'e_bldpop', 0.15, 0.50);
	$losebld += killUnits($emp1, 'e_bldcash', 0.15, 0.50);
	$losebld += killUnits($emp1, 'e_bldtrp', 0.15, 0.50);
	$losebld += killUnits($emp1, 'e_bldcost', 0.15, 0.50);
	$losebld += killUnits($emp1, 'e_bldwiz', 0.15, 0.50);
	$losebld += killUnits($emp1, 'e_bldfood', 0.15, 0.50);
	$losebld += killUnits($emp1, 'e_blddef', 0.15, 0.50);
	$emp1->e_freeland += $losebld;
	$size = $emp1->calcSizeBonus();
	$losefood = killUnits($emp1, 'e_food', 0.15 * $size, 0.45 * $size);
	$loserunes = killUnits($emp1, 'e_runes', 0.15 * $size, 0.45 * $size);
	$losecash = killUnits($emp1, 'e_cash', 0.15 * $size, 0.45 * $size);
	notice(lang('MANAGE_POLYMORPH_OTHER_LOST',
		number($losebld),
		number($losefood), $emp1->era->food,
		number($loserunes), $emp1->era->runes,
		money($losecash)));
	$emp1->e_race = $race;
	$emp1->race = new prom_race($race);
	notice(lang('MANAGE_POLYMORPH_COMPLETE', $emp1->race));
	logevent(varlist(array('race', 'losearm', 'loselnd', 'losefly', 'losesea', 'losepeasants', 'losewiz', 'losebld', 'losefood', 'loserunes', 'losecash'), get_defined_vars()));
} while (0);
if ($action == 'tax') do
{
	$tax = fixInputNum(getFormVar('tax_newrate'));
	if (!$tax)
	{
		notice(lang('MANAGE_TAX_NEED_RATE'));
		break;
	}
	if ($tax < 5)
	{
		notice(lang('MANAGE_TAX_TOO_LOW'));
		break;
	}
	if ($tax > 70)
	{
		notice(lang('MANAGE_TAX_TOO_HIGH'));
		break;
	}
	$emp1->e_tax = $tax;
	notice(lang('MANAGE_TAX_COMPLETE'));
	logevent(varlist(array('tax'), get_defined_vars()));
} while (0);
if ($action == 'industry') do
{
	$arm = fixInputNum(getFormVar('industry_arm'));
	$lnd = fixInputNum(getFormVar('industry_lnd'));
	$fly = fixInputNum(getFormVar('industry_fly'));
	$sea = fixInputNum(getFormVar('industry_sea'));
	if (($arm + $lnd + $fly + $sea) > 100)
	{
		notice(lang('MANAGE_INDUSTRY_TOO_HIGH'));
		break;
	}
	$emp1->e_indarm = $arm;
	$emp1->e_indlnd = $lnd;
	$emp1->e_indfly = $fly;
	$emp1->e_indsea = $sea;
	notice(lang('MANAGE_INDUSTRY_COMPLETE'));
	logevent(varlist(array('arm', 'lnd', 'fly', 'sea'), get_defined_vars()));
} while (0);
if ($action == 'vacation') do
{
	$confirm = fixInputBool(getFormVar('vacation_confirm'));
	if (VACATION_LIMIT == 0)
	{
		notice(lang('MANAGE_VACATION_DISABLED'));
		break;
	}
	if (!ROUND_STARTED)
	{
		notice(lang('MANAGE_VACATION_UNAVAILABLE'));
		break;
	}
	if (!$confirm)
	{
		notice(lang('MANAGE_VACATION_NEED_CONFIRM'));
		break;
	}
	if (!($emp1->e_flags & EFLAG_VALID))
	{
		notice(lang('MANAGE_VACATION_NEED_VALIDATE'));
		break;
	}
	if (ROUND_CLOSING)
	{
		notice(lang('MANAGE_VACATION_TOO_LATE'));
		break;
	}
	$emp1->e_vacation = 1;
	$emp1->setFlag(EFLAG_NOTIFY);
	notice(lang('MANAGE_VACATION_COMPLETE', VACATION_START));
	logevent();
} while (0);
if ($action == 'unvacation') do
{
	if ($emp1->e_vacation == 0)
	{
		notice(lang('MANAGE_UNVACATION_NOT_NEEDED'));
		break;
	}
	if (!$emp1->is_vacation_done())
	{
		notice(lang('MANAGE_UNVACATION_NOT_YET'));
		break;
	}

	$emp1->e_vacation = 0;
	$emp1->e_idle = CUR_TIME;
	$emp1->clrFlag(EFLAG_NOTIFY);
	notice(lang('MANAGE_UNVACATION_COMPLETE'));
	logevent();
} while (0);
// Account Settings
// The action handlers for 'style' and 'language' are located within page_header()
// so that their updates can take effect immediately
if ($action == 'password') do
{
	$newpass = getFormVar('password_new');
	$chkpass = getFormVar('password_verify');
	if (!strlen($newpass))
	{
		notice(lang('INPUT_NEED_PASSWORD'));
		break;
	}
	if ($newpass != $chkpass)
	{
		notice(lang('INPUT_PASSWORD_MISMATCH'));
		break;
	}
	$user1->setPassword($newpass);
	notice(lang('MANAGE_PASSWORD_COMPLETE'));
	logevent();
} while (0);
if ($action == 'timezone') do
{
	$newzone = fixInputNumSigned(getFormVar('zone_new'));
	$user1->u_timezone = $newzone;
	notice(lang('MANAGE_TIMEZONE_COMPLETE'));
	logevent(varlist(array('newzone'), get_defined_vars()));
} while (0);
if ($action == 'dateformat') do
{
	$newformat = htmlSpecialChars(getFormVar('dateformat_new'));
	if (strlen($newformat) > 64)
	{
		notice(lang('INPUT_DATEFORMAT_TOO_LONG'));
		break;
	}
	$user1->u_dateformat = $newformat;
	notice(lang('MANAGE_DATEFORMAT_COMPLETE'));
	logevent(varlist(array('newformat'), get_defined_vars()));
} while (0);
notices();
?>
<h2><?=lang('MANAGE_HEADER_EMPIRE')?></h2>
<table style="width:100%">
<tr><td class="ac" rowspan="2" style="width:30%">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><th><?=lang('MANAGE_POLYMORPH_LABEL')?></th></tr>
        <tr><td class="ac"><?
if ($emp1->e_turnsused != 0)
	echo lang('MANAGE_POLYMORPH_REQUIREMENT', TURNS_INITIAL, number($emp1->e_land * 3), $emp1->era->trpwiz);
else	echo lang('MANAGE_POLYMORPH_NOPENALTY');
?></td></tr>
<?
foreach ($races as $rid => $rname)
{
?>
        <tr><td><?=radiobutton('polymorph_race', $rname, $rid, ($rid == $emp1->e_race))?></td></tr>
<?
}
if ($emp1->e_turnsused != 0)
{
?>
        <tr><td class="ac"><?=checkbox('polymorph_confirm', lang('MANAGE_POLYMORPH_CONFIRM'))?></td></tr>
<?
}
?>
        <tr><th><input type="hidden" name="action" value="polymorph" /><input type="submit" value="<?=lang('MANAGE_POLYMORPH_SUBMIT')?>" /></th></tr>
        </table>
        </form>
    </td>
    <td class="ac" style="width:35%">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><td><?=lang('MANAGE_TAX_LABEL')?></td>
            <td class="ar"><input type="text" name="tax_newrate" size="3" value="<?=percent($emp1->e_tax)?>" /></td></tr>
        <tr><th colspan="2"><input type="hidden" name="action" value="tax" /><input type="submit" value="<?=lang('MANAGE_TAX_SUBMIT')?>" /></th></tr>
        </table>
        </form>
    </td>
    <td class="ac" style="width:35%">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><th colspan="2"><?=lang('MANAGE_INDUSTRY_LABEL')?></th></tr>
        <tr><td><?=lang($emp1->era->trparm)?></td>
            <td class="ar"><input type="text" name="industry_arm" size="3" value="<?=percent($emp1->e_indarm)?>" /></td></tr>
        <tr><td><?=lang($emp1->era->trplnd)?></td>
            <td class="ar"><input type="text" name="industry_lnd" size="3" value="<?=percent($emp1->e_indlnd)?>" /></td></tr>
        <tr><td><?=lang($emp1->era->trpfly)?></td>
            <td class="ar"><input type="text" name="industry_fly" size="3" value="<?=percent($emp1->e_indfly)?>" /></td></tr>
        <tr><td><?=lang($emp1->era->trpsea)?></td>
            <td class="ar"><input type="text" name="industry_sea" size="3" value="<?=percent($emp1->e_indsea)?>" /></td></tr>
        <tr><th colspan="2"><input type="hidden" name="action" value="industry" /><input type="submit" value="<?=lang('MANAGE_INDUSTRY_SUBMIT')?>" /></th></tr>
        </table>
        </form>
    </td></tr>
<tr><td colspan="2" class="ac">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><th><?=lang('MANAGE_VACATION_LABEL')?></th></tr>
<?
if (VACATION_LIMIT == 0)
{
?>
        <tr><td class="ac"><?=lang('MANAGE_VACATION_DISABLED')?></td></tr>
<?
}
elseif (ROUND_CLOSING)
{
?>
        <tr><td class="ac"><?=lang('MANAGE_VACATION_TOO_LATE')?></td></tr>
<?
}
else
{
?>
        <tr><td class="ac"><?=lang('MANAGE_VACATION_EXPLAIN', VACATION_LIMIT, VACATION_START)?></td></tr>
        <tr><td class="ac"><?=checkbox('vacation_confirm', lang('MANAGE_VACATION_CONFIRM'))?></td></tr>
        <tr><th><input type="hidden" name="action" value="vacation" /><input type="submit" value="<?=lang('MANAGE_VACATION_SUBMIT')?>" /></th></tr>
<?
}
?>
        </table>
        </form>
    </td></tr>
</table>

<h2><?=lang('MANAGE_HEADER_ACCOUNT')?></h2>
<table style="width:100%">
<tr><td class="ac" style="width:50%">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><th><?=lang('MANAGE_STYLE_LABEL')?></th></tr>
<?
for ($i = 0; isset($styles[$i]); $i++)
{
?>
        <tr><td><?=radiobutton('style_new', $styles[$i]['name'], $i, ($user1->u_style == $i))?></td></tr>
<?
}
?>
        <tr><th><input type="hidden" name="action" value="style" /><input type="submit" value="<?=lang('MANAGE_STYLE_SUBMIT')?>" /></th></tr>
        </table>
        </form>
    </td>
    <td class="ac" style="width:50%">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><th colspan="2"><?=lang('MANAGE_PASSWORD_LABEL')?></th></tr>
        <tr><td><?=lang('LABEL_PASSWORD_NEW')?></td>
            <td><input type="password" name="password_new" size="8" /></td></tr>
        <tr><td><?=lang('LABEL_PASSWORD_VERIFY')?></td>
            <td><input type="password" name="password_verify" size="8" /></td></tr>
        <tr><th colspan="2"><input type="hidden" name="action" value="password" /><input type="submit" value="<?=lang('MANAGE_PASSWORD_SUBMIT')?>" /></th></tr>
        </table>
        </form>
    </td></tr>
<tr><td class="ac">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><td><?=lang('MANAGE_TIMEZONE_LABEL')?></td>
            <td><?
$zonelist = array();
foreach ($timezones as $offset => $name)
	$zonelist[$offset] = $name;
echo optionlist('zone_new', $zonelist, $user1->u_timezone);
?></td></tr>
        <tr><td><?=lang('MANAGE_TIMEZONE_SAMPLE')?></td><td><?=$user1->customdate(CUR_TIME)?></td></tr>
        <tr><th colspan="2"><input type="hidden" name="action" value="timezone" /><input type="submit" value="<?=lang('MANAGE_TIMEZONE_SUBMIT')?>" /></th></tr>
        </table>
        </form>
    </td>
    <td class="ac">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><td><?=lang('MANAGE_LANGUAGE_LABEL')?></td>
            <td><?
$langlist = array();
foreach ($lang as $id => $data)
	$langlist[$id] = $data['LANG_ID'];
echo optionlist('lang_new', $langlist, $user1->u_lang);
?></td></tr>
        <tr><th colspan="2"><input type="hidden" name="action" value="language" /><input type="submit" value="<?=lang('MANAGE_LANGUAGE_SUBMIT')?>" /></th></tr>
        </table>
        </form>
    </td></tr>
<tr><td class="ac">
        <form method="post" action="?location=manage">
        <table class="inputtable">
        <tr><td><?=lang('MANAGE_DATEFORMAT_LABEL')?></td>
            <td><input type="text" name="dateformat_new" value="<?=$user1->u_dateformat?>" size="16" /></td></tr>
        <tr><td colspan="2"><?=lang('MANAGE_DATEFORMAT_EXPLAIN')?></td></tr>
        <tr><th colspan="2"><input type="hidden" name="action" value="dateformat" /><input type="submit" value="<?=lang('MANAGE_DATEFORMAT_SUBMIT')?>" /></th></tr>
        </table>
        </form>
    </td>
    <td class="ac">
    </td></tr>
</table>
<?
page_footer();
?>
