<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2010 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_4/pages/topempires.php $
 * $Id: topempires.php 1764 2010-10-01 01:13:32Z Quietust $
 */

if (!defined('IN_GAME'))
	die('Access denied');

if (CLAN_ENABLE)
	$cnames = prom_clan::getNames();
$races = prom_race::getNames();
$eras = prom_era::getNames();

$sortcol = getFormVar('sortcol', 'rank');
$sortdir = getFormVar('sortdir', 'asc');

$sorttypes = array(
	'_default'	=> 'rank',
	'rank'		=> array('e_rank {DIR}'),
	'networth'	=> array('e_networth {DIR}, e_rank ASC'),
	'offtotal'	=> array('e_offtotal {DIR}, e_rank ASC'),
	'deftotal'	=> array('e_deftotal {DIR}, e_rank ASC'),
	'kills'		=> array('e_kills {DIR}, e_rank ASC'),
);
if (SCORE_ENABLE)
	$sorttypes['score'] = array('e_score {DIR}, e_rank ASC', 'e_score');
$sortby = parsesort($sortcol, $sortdir, $sorttypes);

$numempires = $db->queryCell('SELECT COUNT(*) FROM '. EMPIRE_TABLE .' WHERE u_id > 0');
$online = $db->queryCell('SELECT COUNT(*) FROM '. EMPIRE_TABLE .' WHERE u_id > 0 AND e_flags & ? != 0', array(EFLAG_ONLINE));
$killed = $db->queryCell('SELECT COUNT(*) FROM '. EMPIRE_TABLE .' WHERE u_id = 0 AND e_land = 0');
$abandoned = $db->queryCell('SELECT COUNT(*) FROM '. EMPIRE_TABLE .' WHERE u_id = 0 AND e_land > 0');
$disabled = $db->queryCell('SELECT COUNT(*) FROM '. EMPIRE_TABLE .' WHERE u_id > 0 AND e_flags & ? != 0', array(EFLAG_DISABLE));

$html = new prom_html_compact();
$html->begin('TOPEMPIRES_TITLE');
?>
<h2><?=lang('TOPEMPIRES_HEADER')?></h2>
<?=gmdate('r', CUR_TIME)?><br /><br />
<?=lang('TOPEMPIRES_ALIVE')?> <span class="cneutral"><?=$numempires?></span><br />
<?=lang('TOPEMPIRES_ONLINE')?> <span class="cgood"><?=$online?></span><br />
<?=lang('TOPEMPIRES_DEAD')?> <span class="mdead"><?=$killed?></span> + <span class="mdead"><?=$abandoned?></span><br />
<?=lang('TOPEMPIRES_DISABLED')?> <span class="mdisabled"><?=$disabled?></span><br />
<b><?=lang('TOPEMPIRES_NOTE_UPDATES', plural(TURNS_FREQ, 'MINUTES_SINGLE', 'MINUTES_PLURAL'))?></b><br /><br />
<?=lang('COMMON_COLORKEY')?> <span class="mprotected"><?=lang('COMMON_COLOR_PROTECT')?></span> - <span class="mdead"><?=lang('COMMON_COLOR_DEAD')?></span> - <span class="mdisabled"><?=lang('COMMON_COLOR_DISABLED')?></span> - <span class="madmin"><?=lang('COMMON_COLOR_ADMIN')?></span><br />
<?=lang('TOPEMPIRES_NOTE_ONLINE')?><br />
<table class="scorestable">
<tr class="era0">
    <th class="ar"><?=sortlink(lang('COLUMN_RANK'), '?location=topempires&amp;', $sortcol, $sortdir, 'rank', 'asc')?></th>
    <th class="ac"><?=lang('COLUMN_EMPIRE')?></th>
    <th class="ar"><?=lang('COLUMN_LAND')?></th>
    <th class="ar"><?=sortlink(lang('COLUMN_NETWORTH'), '?location=topempires&amp;', $sortcol, $sortdir, 'networth', 'desc')?></th>
<?	if (CLAN_ENABLE) { ?>
    <th class="ac"><?=lang('COLUMN_CLAN')?></th>
<?	} ?>
<?	if (SCORE_ENABLE) { ?>
    <th class="ac"><?=sortlink(lang('COLUMN_SCORE'), '?location=topempires&amp;', $sortcol, $sortdir, 'score', 'desc')?></th>
<?	} ?>
    <th class="ac"><?=lang('COLUMN_RACE')?></th>
    <th class="ac"><?=lang('COLUMN_ERA')?></th>
    <th class="ac"><?=sortlink(lang('COLUMN_ATTACKS'), '?location=topempires&amp;', $sortcol, $sortdir, 'offtotal', 'desc')?></th>
    <th class="ac"><?=sortlink(lang('COLUMN_DEFENDS'), '?location=topempires&amp;', $sortcol, $sortdir, 'deftotal', 'desc')?></th>
    <th class="ac"><?=sortlink(lang('COLUMN_KILLS'), '?location=topempires&amp;', $sortcol, $sortdir, 'kills', 'desc')?></th></tr>
<?
$sql = 'SELECT e_rank,e_name,e_id,e_land,e_networth,c_id,e_race,e_era,e_flags,e_turnsused,e_vacation,e_offsucc,e_offtotal,e_defsucc,e_deftotal,e_kills,e_score FROM '. EMPIRE_TABLE .' WHERE u_id > 0 ORDER BY '. $sortby;
$sql = $db->setLimit($sql, TOPEMPIRES_COUNT);
$topempires = $db->query($sql) or warning('Failed to fetch top empires listing', 0);
while ($data = $topempires->fetch())
{
	$emp_a = new prom_empire($data['e_id']);
	$emp_a->initdata($data);

	$color = 'normal';
	if (($emp_a->e_land == 0) || ($emp_a->e_flags & EFLAG_DELETE))
		$color = 'dead';
	elseif ($emp_a->e_flags & EFLAG_ADMIN)
		$color = 'admin';
	elseif ($emp_a->e_flags & EFLAG_DISABLE)
		$color = 'disabled';
	elseif ($emp_a->is_protected() || $emp_a->is_vacation())
		$color = 'protected';
?>
<tr class="m<?=$color?>">
    <td class="ar"><?if ($emp_a->e_flags & EFLAG_ONLINE) echo "*";?><?=$emp_a->e_rank?></td>
    <td class="ac"><?=$emp_a?></td>
    <td class="ar"><?=number($emp_a->e_land)?></td>
    <td class="ar"><?=money($emp_a->e_networth)?></td>
<?	if (CLAN_ENABLE) { ?>
    <td class="ac"><?=$cnames[$emp_a->c_id]?></td>
<?	} ?>
<?	if (SCORE_ENABLE) { ?>
    <td class="ac"><?=$emp_a->e_score?></td>
<?	} ?>
    <td class="ac"><?=$races[$emp_a->e_race]?></td>
    <td class="ac"><?=$eras[$emp_a->e_era]?></td>
    <td class="ac"><?=$emp_a->e_offtotal?> (<?=percent($emp_a->e_offsucc / max($emp_a->e_offtotal, 1) * 100)?>)</td>
    <td class="ac"><?=$emp_a->e_deftotal?> (<?=percent($emp_a->e_defsucc / max($emp_a->e_deftotal, 1) * 100)?>)</td>
    <td class="ac"><?=$emp_a->e_kills?></td></tr>
<?
	$emp_a = NULL;
}
// footer row shouldn't have sort links on it
?>
<tr class="era0">
    <th class="ar"><?=lang('COLUMN_RANK')?></th>
    <th class="ac"><?=lang('COLUMN_EMPIRE')?></th>
    <th class="ar"><?=lang('COLUMN_LAND')?></th>
    <th class="ar"><?=lang('COLUMN_NETWORTH')?></th>
<?	if (CLAN_ENABLE) { ?>
    <th class="ac"><?=lang('COLUMN_CLAN')?></th>
<?	} ?>
<?	if (SCORE_ENABLE) { ?>
    <th class="ac"><?=lang('COLUMN_SCORE')?></th>
<?	} ?>
    <th class="ac"><?=lang('COLUMN_RACE')?></th>
    <th class="ac"><?=lang('COLUMN_ERA')?></th>
    <th class="ac"><?=lang('COLUMN_ATTACKS')?></th>
    <th class="ac"><?=lang('COLUMN_DEFENDS')?></th>
    <th class="ac"><?=lang('COLUMN_KILLS')?></th></tr>
</table>
<?
$html->end();
?>
